# coding: utf-8

"""
    Trieve API

    Trieve OpenAPI Specification. This document describes all of the operations available through the Trieve API.

    The version of the OpenAPI document: 0.13.0
    Contact: developers@trieve.ai
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class UserApiKey(BaseModel):
    """
    UserApiKey
    """ # noqa: E501
    api_key_hash: Optional[StrictStr] = None
    blake3_hash: Optional[StrictStr] = None
    created_at: datetime
    dataset_ids: Optional[List[Optional[StrictStr]]] = None
    expires_at: Optional[datetime] = None
    id: StrictStr
    name: StrictStr
    organization_ids: Optional[List[Optional[StrictStr]]] = None
    params: Optional[Any] = None
    role: StrictInt
    scopes: Optional[List[Optional[StrictStr]]] = None
    updated_at: datetime
    user_id: StrictStr
    __properties: ClassVar[List[str]] = ["api_key_hash", "blake3_hash", "created_at", "dataset_ids", "expires_at", "id", "name", "organization_ids", "params", "role", "scopes", "updated_at", "user_id"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UserApiKey from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if api_key_hash (nullable) is None
        # and model_fields_set contains the field
        if self.api_key_hash is None and "api_key_hash" in self.model_fields_set:
            _dict['api_key_hash'] = None

        # set to None if blake3_hash (nullable) is None
        # and model_fields_set contains the field
        if self.blake3_hash is None and "blake3_hash" in self.model_fields_set:
            _dict['blake3_hash'] = None

        # set to None if dataset_ids (nullable) is None
        # and model_fields_set contains the field
        if self.dataset_ids is None and "dataset_ids" in self.model_fields_set:
            _dict['dataset_ids'] = None

        # set to None if expires_at (nullable) is None
        # and model_fields_set contains the field
        if self.expires_at is None and "expires_at" in self.model_fields_set:
            _dict['expires_at'] = None

        # set to None if organization_ids (nullable) is None
        # and model_fields_set contains the field
        if self.organization_ids is None and "organization_ids" in self.model_fields_set:
            _dict['organization_ids'] = None

        # set to None if params (nullable) is None
        # and model_fields_set contains the field
        if self.params is None and "params" in self.model_fields_set:
            _dict['params'] = None

        # set to None if scopes (nullable) is None
        # and model_fields_set contains the field
        if self.scopes is None and "scopes" in self.model_fields_set:
            _dict['scopes'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UserApiKey from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "api_key_hash": obj.get("api_key_hash"),
            "blake3_hash": obj.get("blake3_hash"),
            "created_at": obj.get("created_at"),
            "dataset_ids": obj.get("dataset_ids"),
            "expires_at": obj.get("expires_at"),
            "id": obj.get("id"),
            "name": obj.get("name"),
            "organization_ids": obj.get("organization_ids"),
            "params": obj.get("params"),
            "role": obj.get("role"),
            "scopes": obj.get("scopes"),
            "updated_at": obj.get("updated_at"),
            "user_id": obj.get("user_id")
        })
        return _obj


